Foreman - Bug #10642

Migration of unmanaged host can fail on primary interface
05/28/2015 11:55 AM - Marek Hulan

Status: Closed
Priority: Normal
Assignee: Marek Hulén
Category: DB migrations
Target version: 1.8.2
Difficulty: Fixed in Releases:
Triaged: Found in Releases: 1.8.1
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/2425
Description

If there's unmanaged host with interface that has IP set to it's primary interface but is not marked as primary the migration ends up in
invalid state because db/migrate/20140910153654_move_host_nics_to_interfaces.rb creates new interface (skipping validations)
with this IP and marks it primary. Then second migration - 20150508124600_copy_unmanaged_hosts_to_interfaces.rb - runs but
here it finds the existing one from previous migration and tries to set it's hostname and save it. Unfortunately it's not FakeNic instance
so it runs validations and fails on IP uniqueness validation. We can either try to skip saving of interface if it didn't change or improve
detection of existing primary interface (probably in both migrations). Setting as release 1.8.2, all users with unmanaged hosts with

interfaces created by puppet will hit this.

Migration error that pops up

== CopyUnmanagedHostsToInterfaces: migrating
—— Migrating Unmanaged Host interfaces to standalone Interfaces
rake aborted!

An error has occurred, all later migrations canceled:

Validation failed: IP address has already been taken

Related issues:

Related to Foreman - Bug #10403: Smart Class Parameter Overrides using the FQ... Closed
Related to Foreman - Feature #10260: Allow interfaces management for unmanage... Closed
Related to Foreman - Bug #10571: LDAP authentication management error Resolved

05/06/2015
04/24/2015
05/21/2015

Associated revisions

Revision 19d684dd - 06/08/2015 08:55 AM - Marek Hulan

Fixes #10642 - save the interface regardless of validation errors

Revision 15055fe8 - 06/15/2015 10:09 AM - Marek Hulan

Fixes #10642 - save the interface regardless of validation errors

(cherry picked from commit 19d684ddf481c5ce8b30d234db28e8c336ccc272)

History

#1 - 05/28/2015 11:56 AM - Marek Hulan

- Related to Bug #10403: Smart Class Parameter Overrides using the FQDN fact as a match no longer applies the override added

#2 - 06/01/2015 08:51 AM - Simon Miigge

For us this issue blocks working around that issue: http:/projects.theforeman.org/issues/10571

We should db:migrate to get rid of the LDAP issue (users can't log in) but we can't db:migrate because of all our unmanaged hosts and the migration

breaking.
http://projects.theforeman.org/issues/10571

#3 - 06/03/2015 06:51 AM - Marek Hulan

- Related to Feature #10260: Allow interfaces management for unmanaged hosts added

#4 - 06/03/2015 06:53 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/2425 added
- Pull request deleted ()

#5 - 06/03/2015 07:03 AM - Marek Hulan

The fix will make migration pass keeping interface in potentially invalid state. Invalid IP issue can then be changed through API (we can't do it
automatically). Here's howto use API to fix that

# first find out the id of failing interface (identifier reported by migration)

curl —-user 'admin:S$Sadminpw' 'https://$foreman_url/api/v2/hosts/Shost_fgdn/interfaces'

# update the interface identified by $id with real IP

curl -X PUT -H 'Content-Type: application/json' --user 'admin:$adminpw' -d '{"interface":{"ip":"S$real_ip"}}' '
https://$foreman_url/api/v2/hosts/$host_fgdn/interfaces/$id’

In related task I'll allow interface management from WebUI.

#6 - 06/08/2015 09:01 AM - Marek Hulan
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 19d684ddf481c5ce8b30d234db28e8c336¢ccc272.

#7 - 06/16/2015 03:00 AM - Marek Hulan
- Related to Bug #10571: LDAP authentication management error added

05/18/2024 22


https://projects.theforeman.org/projects/foreman/repository/foreman/revisions/19d684ddf481c5ce8b30d234db28e8c336ccc272
http://www.tcpdf.org

